// NCachedFile.cpp: CNCachedFile NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NCachedFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CNCachedFile::CNCachedFile()
	: CNFile()
{
	m_bIsWritable = FALSE;

	m_pBuff = NULL;
	m_llDataPos = 0;
	m_llDataSize = 0;
	m_dwBuffSize = 0;
	m_llCurPos = 0;
}

CNCachedFile::~CNCachedFile()
{
	Close();
	CNFile::~CNFile();
}

const BOOL CNCachedFile::Open(LPCTSTR lpszName, BYTE bFlags, const DWORD dwBuffSize)
{
	if((bFlags & CNFile::CNF_WRITE) && !(bFlags & CNFile::CNF_READ)){
		// CgLbVL
		m_bIsWritable = TRUE;
		}
	else if(!(bFlags & CNFile::CNF_WRITE) && (bFlags & CNFile::CNF_READ) && !(bFlags & CNFile::CNF_NEW)){
		// [hLbVL
		m_bIsWritable = FALSE;
		}
	else{
		// tȎgݍ킹Ή
		SetLastError(0x00000057);	// up[^܂Bv
		return FALSE;
		}

	// t@CI[v
	if(!CNFile::Open(lpszName, bFlags))return FALSE;

	// obt@m
	if(!m_bIsWritable){
		// ǂݍ݃obt@
		m_dwBuffSize = (dwBuffSize <= GetSize())? dwBuffSize : (DWORD)GetSize();
		}

	if(m_pBuff)delete [] m_pBuff;
	m_pBuff = new BYTE [m_dwBuffSize];
	if(!m_pBuff){
		Close();
		SetLastError(0x0000000E);	// ȗ̂ɏ\ȋL̈悪܂Bv
		return FALSE;
		}

	// obt@
	m_llDataPos = 0;
	m_llDataSize = 0;
	m_llCurPos = 0;

	SetLastError(0x00000000);	// u͐ɏI܂Bv

	return TRUE;
}

void CNCachedFile::Close(void)
{
	// ݃f[^tbV
	Flush();

	CNFile::Close();

	if(m_pBuff){
		delete [] m_pBuff;
		m_pBuff = NULL;
		}
}

const BOOL CNCachedFile::Read(BYTE *pBuff, const DWORD dwLen)
{
	// G[
	if(m_bIsWritable){
		SetLastError(0x00000001);	// usȊ֐łBv
		return FALSE;
		}

	if(!dwLen){
		SetLastError(0x00000057);	// up[^܂Bv
		return FALSE;
		}

	if((m_llCurPos + dwLen) > GetSize()){
		SetLastError(0x00000026);	// ut@C̏IɒB܂Bv
		return FALSE;
		}

	SetLastError(0x00000000);		// u͐ɏI܂Bv

	// LbV
	if(m_llDataSize > 0){
		if((m_llCurPos >= m_llDataPos) && ((m_llCurPos + dwLen) <= (m_llDataPos + m_llDataSize))){
			// 1
			CopyMemory(pBuff, m_pBuff + (m_llCurPos - m_llDataPos), dwLen);
			m_llCurPos = m_llCurPos + dwLen;
			}
		else if((m_llCurPos < m_llDataPos) && ((m_llCurPos + dwLen - 1) >= m_llDataPos) && ((m_llCurPos + dwLen) <= (m_llDataPos + m_llDataSize))){
			// 2
			if(!CNFile::Read(pBuff, (DWORD)(m_llDataPos - m_llCurPos), m_llCurPos))return FALSE;
			CopyMemory(pBuff + (m_llDataPos - m_llCurPos), m_pBuff, dwLen - (DWORD)(m_llDataPos - m_llCurPos));
			m_llCurPos = m_llCurPos + dwLen;
			}
		else if((m_llCurPos >= m_llDataPos) && (m_llCurPos <= (m_llDataPos + m_llDataSize - 1)) && ((m_llCurPos + dwLen) > (m_llDataPos + m_llDataSize))){
			// 3
			CopyMemory(pBuff, m_pBuff + (m_llCurPos - m_llDataPos), (DWORD)(m_llDataPos + m_llDataSize - m_llCurPos));
			if((dwLen - (m_llDataPos + m_llDataSize - m_llCurPos)) <= m_dwBuffSize){
				if(!CNFile::Read(m_pBuff, m_dwBuffSize, m_llDataPos + m_llDataSize))return FALSE;
				CopyMemory(pBuff + (m_llDataPos + m_llDataSize - m_llCurPos), m_pBuff, dwLen - (DWORD)(m_llDataPos + m_llDataSize - m_llCurPos));
				m_llDataPos = m_llDataPos + m_llDataSize;
				}
			else{
				if(!CNFile::Read(pBuff, dwLen - (DWORD)(m_llDataPos + m_llDataSize - m_llCurPos), m_llDataPos + m_llDataSize))return FALSE;
				}

			m_llCurPos = m_llCurPos + dwLen;
			}
		else if((m_llCurPos < m_llDataPos) && ((m_llCurPos + dwLen) > (m_llDataPos + m_llDataSize))){
			// 4
			if(!CNFile::Read(pBuff, (DWORD)(m_llDataPos - m_llCurPos), m_llCurPos))return FALSE;
			CopyMemory(pBuff + (m_llDataPos - m_llCurPos), m_pBuff, (DWORD)m_llDataSize);
			if((dwLen - (m_llDataPos + m_llDataSize - m_llCurPos)) <= m_dwBuffSize){
				if(!CNFile::Read(m_pBuff, m_dwBuffSize, m_llDataPos + m_llDataSize))return FALSE;
				CopyMemory(pBuff + (m_llDataPos + m_llDataSize - m_llCurPos), m_pBuff, (DWORD)(m_llCurPos + dwLen - m_llDataPos - m_llDataSize));
				m_llDataPos = m_llDataPos + m_llDataSize;
				}
			else{
				if(!CNFile::Read(pBuff, (DWORD)(m_llCurPos + dwLen - m_llDataPos - m_llDataSize), m_llDataPos + m_llDataSize))return FALSE;
				}

			m_llCurPos = m_llCurPos + dwLen;
			}
		else{
			// 5
			if(dwLen < m_dwBuffSize){			
				if(!CNFile::Read(m_pBuff, m_dwBuffSize, m_llCurPos))return FALSE;
				CopyMemory(pBuff, m_pBuff, dwLen);
				m_llDataPos = m_llCurPos;
				}
			else{
				if(!CNFile::Read(pBuff, dwLen, m_llCurPos))return FALSE;
				}

			m_llCurPos = m_llCurPos + dwLen;
			}
		}
	else{
		if(dwLen < m_dwBuffSize){			
			if(!CNFile::Read(m_pBuff, m_dwBuffSize, m_llCurPos))return FALSE;
			CopyMemory(pBuff, m_pBuff, dwLen);
			m_llDataPos = m_llCurPos;
			m_llDataSize = m_dwBuffSize;
			}
		else{
			if(!CNFile::Read(pBuff, dwLen, m_llCurPos))return FALSE;
			}

		m_llCurPos = m_llCurPos + dwLen;
		}

	return TRUE;
}

const BOOL CNCachedFile::Read(BYTE *pBuff, const DWORD dwLen, const LONGLONG llPos)
{
	if(m_bIsWritable){
		SetLastError(0x00000001);	// usȊ֐łBv
		return FALSE;
		}

	// t@CV[N
	if(Seek(llPos)){
		return Read(pBuff, dwLen);
		}

	return FALSE;
}

const BOOL CNCachedFile::Write(const BYTE *pBuff, const DWORD dwLen)
{
	// t@C
	if(!m_bIsWritable){
		SetLastError(0x00000001);	// usȊ֐łBv
		return FALSE;
		}

	if(!dwLen){
		SetLastError(0x00000057);	// up[^܂Bv
		return FALSE;
		}

	// obt@O
	if((m_dwBuffSize - m_llDataSize) <= dwLen){
		// obt@s
		if(!Flush())return FALSE;
		}

	// obt@O
	if((m_dwBuffSize - m_llDataSize) >= dwLen){
		CopyMemory(m_pBuff + m_llDataSize, pBuff, dwLen);
		m_llDataSize += dwLen;
		}
	else{
		if(!CNFile::Write(pBuff, dwLen, m_llCurPos))return FALSE;
		}

	// t@C|WVXV
	m_llCurPos += dwLen;

	SetLastError(0x00000000);	// u͐ɏI܂Bv

	return TRUE;
}

const BOOL CNCachedFile::Write(const BYTE *pBuff, const DWORD dwLen, const LONGLONG llPos)
{
	// t@C
	if(!m_bIsWritable){
		SetLastError(0x00000001);	// usȊ֐łBv
		return FALSE;
		}

	// t@CV[N
	if(Seek(llPos)){
		return Write(pBuff, dwLen);
		}

	return FALSE;
}

const BOOL CNCachedFile::Seek(const LONGLONG llPos)
{
	// V[NOɃtbV
	if(!Flush())return FALSE;

	// V[N
	if(!CNFile::Seek(llPos))return FALSE;

	// t@C|WVXV
	m_llCurPos = llPos;
	m_llDataPos = m_llCurPos;

	return TRUE;
}

const BOOL CNCachedFile::Flush(void)
{
	if(!m_bIsWritable || !m_llDataSize)return TRUE;

	// obt@擪ʒuɏ
	if(!CNFile::Write(m_pBuff, (DWORD)m_llDataSize, m_llDataPos))return FALSE;

	// t@C|WV𕜋A
	if(!CNFile::Seek(m_llCurPos))return FALSE;

	// obt@TCYNA
	m_llDataSize = 0;
	m_llDataPos = m_llCurPos;

	return TRUE;
}
